/* $Id: court.js,v 1.5 2007-12-22 03:52:51 egarcia Exp $ */
	  var pasos;
	  var paso;
	  var xcenter;
	  var ticks=0;
	  var start = (new Date()).getTime();
	  var stop;

	  var zoom = 1;
	  var height;
	  var width;
	  var paddleWidth;
	  var paddleHeight;
	  var lineHeight;
	  var ballRad;

	  var theCourt = document.getElementById("tablero");
	  var theCourtW = document.getElementById("courtW");
	  var ctx = null;

	  setValues();

	  initCtx(zoom);

	  var counter1 = 0;
	  var counter2 = 0;
	  var yracket1 = height/2;
	  var yracket2 = height/2;
	  var direc1;
	  var direc2;
	  var xball;
	  var yball;
	  var xballinc;
	  var yballinc;
	  var bsi = 0;
	  var started = false;
	  var status = document.getElementById("status");
	  var banner = document.getElementById("banner");
	  var goal = false;
	  var scorer;
	  var ballstep=8;
	  var paddlestep=0;
	  var period = 10;
	  var longPeriod = 40;
	  var intervalID;

	  // Velocidad de las raquetas
	  var inc1 = 0;
	  var inc2 = 0;

	  // Controla los "reflejos", o sea la anticipacin del oponente
	  var torpeza = 0;
	  var torpezaMinima = -30;
	  var lentitud = 0.75;

	  var alea = Math.random()/2;

	  function initCtx(factor) {
	    theCourt.width = width*factor;
	    theCourt.height = height*factor;
	    if( ctx==null) {
		ctx = theCourt.getContext("2d");
	    }
	    ctx.fillStyle = "white";
	    ctx.strokeStyle = "white";
	  }

	  function setValues() {
	    height = 300;
	    width = 400;
	    paddleWidth = 10;
	    paddleHeight = 40;
	    lineHeight = 18;
	    ballRad = 10;
	    pasos=8;
	    paso=(height-2*paddleWidth)/pasos;
	    xcenter = (width-paddleWidth)/2
	  }

	  function tick() {
	    stop = (new Date()).getTime();
	    ticks = stop - start;

	    // Otra forma de calcular el tiempo
	    if( ticks < longPeriod) return;

	    calculateRacket1();
	    if( started) {
		calculateRacket2();
		calculateBall();
		checkBounce();
		if( goal) {
		    goal = false;
		    if( scorer==1) {
			counter1++;
		    } else {
			counter2++;
		    }
		    // Ajusta torpeza
		    torpeza = torpezaMinima + (30 * (counter2-counter1));
		    if( torpeza > 150) {
			torpeza = 150;
		    } else if( torpeza < -30 ) {
			torpeza = -30;
		    }
		    initCourt();
		}
	    }
	    repaint();
	    start = (new Date()).getTime();
	  }

	  function repaint() {
	    clearCourt();
	    if( started) {
		paintBall();
	    }
	    paintRackets();
	    paintLine();
	    paintSpeedMeter();
	  }

	  function checkBounce() {
	    var bounce = false;
	    if( xball <=paddleWidth) {
		if( (yball>(yracket1-5)) && (yball<(yracket1+40))) {
		    alea = Math.random()*ballstep/2;
		    if( xballinc > 0) {
			xballinc = -ballstep-bsi-alea+0.5;
		    } else {
			xballinc = ballstep+bsi+alea-0.5;
		    }
		    bounce = true;
		    xball = paddleWidth;
		} else {
		    scorer = 2;
		    goal = true;
		}
	    } else if( xball >= (width-20)) {
		if( (yball>(yracket2-5)) && (yball<(yracket2+40))) {
		    alea = Math.random()*ballstep/2;
		    if( xballinc > 0) {
			xballinc = -ballstep-bsi-alea+0.5;
		    } else {
			xballinc = ballstep+bsi+alea-0.5;
		    }
		    bounce = true;
		    xball = width-20;
		} else {
		    scorer = 1;
		    goal = true;
		}
	    }
	    if( bounce) {
		if( ballstep+bsi < 16) {
		    bsi += 0.5;
		    /*
		    inc1 = paddlestep;
		    // La raqueta del contrario en ms lenta!
		    inc2 = inc1*lentitud;
		    */
		}
	    }
	  }

	  function calculateRacket1() {
	    if(direc1>0) {
		if( (yracket1<=height-paddleWidth-paddleHeight)) {
		    yracket1+=direc1;
		    if( direc1>0) {
			direc1-=amort;
		    }
		}
	    } else {
		if( yracket1 >= paddleWidth) {
		    yracket1+=direc1;
		    if( direc1<0) {
			direc1+=amort;
		    }
		}
	    }
	  }
	  function calculateRacket2() {
	    // Controla los "reflejos", o sea la anticipacin del oponente
	    if( xball < width/2+torpeza){
		direc2=0;
	    } else {
		var diff = yball - (yracket2+20);
		if( diff > 0) {
		    direc2 = inc2;
		} else {
		    direc2 = -inc2;
		}
	    }
	    if(direc2>0) {
		if( (yracket2<=height-paddleWidth-paddleHeight)) {
		    yracket2+=direc2;
		}
	    } else {
		if( yracket2 >= paddleWidth) {
		    yracket2+=direc2;
		}
	    }
	  }

	  function calculateBall() {
	    xball += xballinc;
	    yball += yballinc;
	    if( (yball>(height-paddleWidth-ballRad)) || (yball<=paddleWidth)) {
		yballinc = -yballinc;
	    }
	  }

	  function clearCourt() {
	    ctx.clearRect(0,0,2*width,2*height);
	  }

	  function paintRackets() {
	    ctx.fillRect(5,yracket1,paddleWidth, paddleHeight);
	    ctx.fillRect(width-15,yracket2,paddleWidth, paddleHeight);
	  }

	  function paintBall() {
	    ctx.fillRect(xball,yball,ballRad, ballRad);
	  }
	  function clearBall() {
	    ctx.clearRect(xball,yball,ballRad, ballRad);
	  }

	  function paintLine() {
	    for(var i=paddleWidth*2; i< height; i+=paso) { 
		ctx.fillRect(xcenter, i, paddleWidth, lineHeight);
	    }
	    ctx.fillRect(0, 0, width, paddleWidth);
	    ctx.fillRect(0, height-paddleWidth, width, paddleWidth);
	  }

	  function paintSpeedMeter() {
	    if( ballstep<=8) {
		ctx.fillStyle = "green";
	    } else if( ballstep<=12) {
		ctx.fillStyle = "yellow";
	    } else {
		ctx.fillStyle = "red";
	    }
	    ctx.fillRect(width-2*ballstep, height-paddleWidth, 2*ballstep, paddleWidth);
	    ctx.fillStyle = "white";
	  }

	  function keyReleased(event) {
	    if( (code == KeyboardEvent.DOM_VK_Q) || (code == KeyboardEvent.DOM_VK_A) ){
		amort = inc1/35;
	    }
	  }

	  function keyPressed(event) {
	    code = event.keyCode;
	    if( code == KeyboardEvent.DOM_VK_Q) {
		direc1 = -inc1;
		amort=0;
	    } else if( code == KeyboardEvent.DOM_VK_A) {
		direc1 = inc1;
		amort=0;
	    } else if( code == KeyboardEvent.DOM_VK_Z) {
		if( longPeriod == 100) {
		    longPeriod = 25;
		} else {
		    longPeriod = 100;
		}
		window.clearInterval(intervalID);
		intervalID = window.setInterval('tick()', period);
	    } else if( code == KeyboardEvent.DOM_VK_S)  {
		if( !started) {
		    started = true;
		    alea = Math.random()*ballstep/2;
		    xball=width-15-10;
		    yball=yracket2+20;
		    xballinc=-ballstep;
		    yballinc= ballstep+alea-0.5;
		    status.value= counter1 + " - " + counter2;
		}
	    } else if( code == KeyboardEvent.DOM_VK_1) {
		if( zoom>=1) {
		    zoom /= 2;
		    window.fullScreen=false;
		    theCourtW.width=415*zoom;
		    initCtx(zoom);
		    window.resizeTo(415*zoom,355*zoom);
		    status.setAttribute("style", "font-family: arial; font-size:" + 24*zoom + "pt;");
		    banner.setAttribute("style", "font-family: arial; font-size:" + 12*zoom + "pt;");
		    ctx.scale(zoom,zoom);
		    repaint();
		}
	    } else if( code == KeyboardEvent.DOM_VK_2) {
		if( zoom<=1) {
		    zoom *= 2;
		    if( zoom == 2) {
			theCourtW.width=screen.width;
			window.fullScreen=true;
		    } else {
			theCourtW.width=415*zoom;
			window.resizeTo(415*zoom,355*zoom);
		    }
		    initCtx(zoom);
		    status.setAttribute("style", "font-family: arial; font-size:" + 24*zoom + "pt;");
		    banner.setAttribute("style", "font-family: arial; font-size:" + 12*zoom + "pt;");
		    ctx.scale(zoom,zoom);
		    repaint();
		}
	    } else if( code == KeyboardEvent.DOM_VK_B) {
		window.close();
	    } else if( code == KeyboardEvent.DOM_VK_X) {
		window.close();
	    } else if( code == KeyboardEvent.DOM_VK_O) {
		if( ballstep<16) {
		    ballstep++;
		}
	    } else if( code == KeyboardEvent.DOM_VK_P) {
		if( ballstep>4) {
		    ballstep--;
		}
	    }
	  }

	  function initCourt() {
	    direc1=0;
	    direc2=0;
	    xballinc=0;
	    yballinc=0;
	    paddlestep = 8;
	    inc1 = paddlestep;
	    inc2 = paddlestep;
	    bsi=0;
	    started=false;
	    status.value= "Press S key to serve...";
	  }

	  /////////////////
	  // Main
	  /////////////////
	  initCourt();
	  status.value= "Press S key to serve...";
	  paintRackets();
	  paintLine();
	  intervalID = window.setInterval('tick()', period);
	  window.addEventListener('keydown', keyPressed, true);
	  window.addEventListener('keyup', keyReleased, true);
	  paintBall();
